#include <stdio.h>          // version:  2012,4,25
#define n48    41           // omr data number of a line
#define n3000  3000         // assume: 3000, is MAX lines of a omr_pic
unsigned char aa[3000][n48];
#define n2048  2048         // assume: one interput data length
#define n160    160         // assume: 160,  is MAX lines of a omr_map
char tab[n160][41];
int  posi[n160];

int  fch;                   // interput counter
int  old_fch=255;           // if(fch<old_fch), initial cut()
FILE *fp;
char f1[12],c63;            // out map filename: c63.map  64~127
                            // data package identify.
#define p3     3        // ignor  value
#define sigma  3        // bias,  edge, m20
#define sig20  3        // bias,  edge, m20
#define m5     3        // 0-m5 no 3bit out
#define p6     8        // mark minum width 8 poshort  ~15,16
#define hwmax 30
#define hw     6
#define  white8 8
#define  p10    9                       // median line= lowest_peak-10
#define  m60   55
#define  m40   40

int  bar=1;             //
int  p40;               // little adjusted in processing routine
int  p60;
int  tpt11=1;

int  bip,jp,x_c,x_w,c,cc,n41,bias3;     // for cut used, ip also for bar()
char slip[41],bias[41],c_xpeak[41];
char a[99],b[512];                      // output data, bar work array


/*     2012,4,25, demonstrating: scan 8 times  
       in 3rd (interupt 10),  make a hardware_error for simulation.
main()
{
  int i,j;
  int error;
  p60=m60; p40=m40;

  fp=fopen("1.41","rb");  fread(aa,n3000,n48,fp);  fclose(fp);

  for(j=1;j<9;j++){  c63=j;     // assume: do 8 times scan
    for(i=0;i<99;i++){
      fch=i;
      if(j==3 && i==10)error=1; else error=0;
      cut(fch,c63,error);       // I do not know, last fch==??
      if(old_fch==999)break;    // so arrange this line.
    }
  }
}
*/

main(int ac,char **av)
{
  int i,j;
  int error;
  p60=m60; p40=m40;
  if(ac<2){ printf("\n\t*** Simulating omr2000 scanning a sheet ****\n");
            printf("\n\tUsage: cut3 1.41     (scaned pic)\n\n");
            exit(0); }
  fp=fopen(av[1],"rb"); if(!fp){ printf("%s not found!\n",av[1]); exit(0); }
  fread(aa,n3000,n48,fp);  fclose(fp);
  c63=error=0; fch=99; 
  cut(fch,c63,error);
}

//-------------- 

int nx,ns,ipeak,xpeak,xpeak0,ipp,dp,dx,shift;
cut(int fch,char c63,int error)
{
  int i,j,k,l, k20,k33;
  int sx,sz;
  char  points,  sort[9];

  if(fch < old_fch){         // initial
    ipp=jp=nx=ipeak=0;  n41=41;  shift=64;
    for(i=0;i<n41;i++){ bias[i]=p60; slip[i]=0; }
    for(i=0;i<n160;i++)for(j=0;j<n41;j++)tab[i][j]=0;
    sprintf(f1,"%03d.map",c63);
    fp=fopen(f1,"wb");
  } old_fch=fch;

L3:
  if(error)goto L10;                         // error is "handware_error"
                                             // if true, exit cut() at once.
  if((fch-2)*n2048/n48<nx) return;           // data not buffered yet
L10:
  nx++;  cc=aa[nx][0];
  if(cc>63 || nx>n3000 || error ){
    a[0]='*';   a[1]=error;   a[2]=shift;   a[3]=fch;    a[4]=c63;
    fwrite(a,1,5,fp);
printf("* err: %d shift: %d fch: %d c63: %d\n",error,shift,fch,c63);
    if(bar && error==0)do_bar();
    fclose(fp);
    old_fch=999;                             // old_fch=999; cut() is finished
    return;
  }
  if(cc+2>=p40 && ipp==0)goto L3;              // for 1ST black
  ipp=255;
  if(jp==0){                                   // find 1st mark
    for(i=0;i<n41;i++) if(bias[i]>aa[nx][i])bias[i]=aa[nx][i];
    if(cc>p40 && ipeak==0){  ipeak=1;  ns=nx-1; }     // find left_edge
    if(ipeak==1 && cc<p40) {                          // find right_edge
      x_c=xpeak=(ns+nx)>>1;  x_w=6;
      if(nx-ns <p6 )goto L99;
      for(i=1;i<n41;i++){                             // cal slip
        k=sx=cc=0;
        for(j=xpeak-x_w;j<=xpeak+x_w;j++){
          sz=aa[j][i];  if(sz>cc)cc=sz;
          k+=(sz*j);    sx+=sz;
        }
        if(sx<1)sx=1;   xpeak=(k*2/sx+1)>>1;
        slip[i]=xpeak-x_c;                             // if end
        l=aa[xpeak][i]-cc;
        if(l<0)l=-l; if(l>sigma)slip[i]=slip[i-1];
        cc=cc*3/4; l=0; k=xpeak-30; if(k<10)k=10;
        for(j=xpeak;j>k;j--)if(cc>aa[j][i])goto l31;
        l=1;
l31:
        if(l!=1)l=l; else slip[i]=slip[i-1];
        if(i==15 && l==1)goto l30;                     // no black line
        if(i>15 && l==1 && aa[xpeak][i]>=p40)break;
      }
      n41=i;                                           // n41=i-1; 20120425
l30:
      jp=1;
    }
  }
  if(jp){
    if(cc>p40 && ipeak==0){  ipeak=1;  ns=nx-1;    }   // find left
    if(ipeak==1 && cc<p40) {                           // find right
      xpeak0=xpeak;    xpeak=(ns+nx)>>1;
      posi[jp]=xpeak;  if(nx-ns <p6 )goto L99;
      x_w=(nx-ns)>>1;  if(x_w>hwmax)x_w=hwmax;
      if(nx-ns-3 > dp && tpt11==1 && jp>3){
        xpeak=xpeak0; nx=xpeak+(dp*5)/4;  xpeak0=nx+dp/2;
        for(i=nx;i<xpeak0;i++)aa[i][0]=bias[0];
        goto L3;
      }
      l=xpeak-xpeak0;
      if(jp==2){ dp=l; dx=nx-ns+3; }
      if(jp==3 && l<dp){ dp=l; dx=nx-ns+3; }
      if(tpt11==1 && jp>3 && nx-ns>dx) xpeak=xpeak0+dp;
      if(jp==1){
        p40=(aa[xpeak][0]-bias[0])/2+bias[0];
        if(p40>45)p40=45; if(p40<36)p40=36;
      }
      for(i=1;i<n41;i++){
        if(p60-bias[i]<10){ n41=i; break; }
        k=xpeak+slip[i];
        c= points=0; bias3=3*(p60-bias[i])/15+bias[i];  // find peak
        for(j=k-x_w;j<=k+x_w;j++){
          if(aa[j][i]>c){ c=aa[j][i]; x_c=j; }          // find posi
          if(aa[j][i]>bias3)points++;
        }
        calcck20(i);
        if(cc<=1){
          l=0; for(j=k-4;j<=k+4;j++)sort[l++]=aa[j][i];
          for(j=0;j<8;j++)for(l=j+1;l<9;l++)if(sort[j]>sort[l]){
            k20=sort[l]; sort[l]=sort[j]; sort[j]=k20;
          }
          j=bias[i]-sort[4]; if(j<0)j=-j;
          bias[i]=(j<=sigma)?sort[4]:(bias[i]+sort[4])/2;
        }
        if(cc<p3)cc=0; else if( points*3 < x_w*2 )jduge(i,k);
        if(cc>m5){
          k20=findk(i,20);   k33=findk(i,33); if(k20==0)k20=1;
          k=40-(k33*24/k20); k=findk(i,k);
          l=k/6; if(l>7)l=7; l<<=4;   cc|=l;
        }
        a[i]=cc; c_xpeak[i]=x_c-xpeak;
      }
      for(j=n41-1;j>2;j--)if(a[j])break;

//if(jp==1)printf("****%d %d***\n",j,n41);

printf("%02d: ",jp);
for(i=1;i<=j;i++)if(a[i]==0)printf("   ");else printf("%02x ",a[i]);
//printf("\n%02d: ",jp);
//for(i=1;i<=n41;i++)printf("%02x ",aa[xpeak][i]);

printf("\n");
      fputc(0x23,fp); fputc(j,fp);  fwrite(a,1,j,fp);
      for(i=1;i<=j;i++)if(a[i]==0)goto l50;
      shift=c_xpeak[j]-slip[j];
l50:
      if(jp<n160-1)jp++;  ipeak=0;
    }
  }
  goto L3;
L99: ipeak=0;
  goto L3;
}

jduge(int i,int k)
{
  int j;
  if(aa[k-x_w][i]>=bias3){
    for(j=k-x_w;j>=k+2*x_w;j--){
      if(aa[j][i]>c)c=aa[j][i]; if(aa[j][i]<bias3){ calcck20(i); return; }
    } cc=0;
  }
  if(aa[k+x_w][i]>=bias3){
    for(j=k+x_w;j<=k+2*x_w;j++){
      if(aa[j][i]>c)c=aa[j][i]; if(aa[j][i]<bias3){ calcck20(i); return; }
    } cc=0;
  }
}

calcck20(int i)
{
  int j;
  cc=(c-bias[i])*15/(p60-bias[i]);  if(cc>15)cc=15; if(cc<0)cc=0;
  j=cc; tab[jp][i]=(j<10)?0:1;     // for bar
}

int findk(int i, int kk)
{
  int j,k,m20,m80;
l20:
  k=0;
  m80=(c-bias[i])*9/10+bias[i];
  m20=(c-bias[i])*kk/100; if(m20<sig20)m20=sig20; m20+=bias[i];
  for(j=x_c;j>x_c-p60;j--){
    if(aa[j][i]<m80)k++; if(c<aa[j][i]){ c=aa[j][i]; goto l20; }
    if(aa[j][i]<m20)break;
  }
  for(j=x_c;j<x_c+p60;j++){
    if(aa[j][i]<m80)k++; if(c<aa[j][i]){ c=aa[j][i]; goto l20; }
    if(aa[j][i]<m20)break;
  }
  return(k);
}

int  mta[108]={
0x455,0x545,0x554,0x116,0x125,0x215,0x152,0x161,0x251,0x512,0x521,0x611,
0x059,0x149,0x158,0x095,0x185,0x194,0x590,0x509,0x518,0x491,0x581,0x848,
0x815,0x905,0x914,0x851,0x941,0x950,0x446,0x464,0x644,0x026,0x206,0x224,
0x062,0x242,0x260,0x422,0x602,0x620,0x04a,0x068,0x248,0x086,0x0a4,0x284,
0x884,0x428,0x608,0x482,0x4a0,0x488,0x806,0x824,0xa04,0x842,0x860,0xa40,
0x8c0,0x530,0xe00,0x017,0x035,0x107,0x134,0x305,0x314,0x053,0x071,0x143,
0x170,0x341,0x350,0x710,0x503,0xc80,0x701,0x2c0,0x01d,0x10d,0x11c,0x0d1,
0x1c1,0x1d0,0xc11,0xd01,0xd10,0x44c,0x4c4,0xc44,0x00e,0x02c,0x20c,0x0c2,
0x0e0,0xc02,0xc20,0x08c,0x0c8,0x80c,0xc08,0x431,0x413,0x419,0x680,0x40a};
do_bar()
{
  int i,j,k;
  for(j=2;j<jp-1;j++) for(i=1;i<n41;i++){
    if(tab[j][i]==0)continue;
    if(tab[j-1][i]+tab[j+1][i]==0)tab[j][i]=0;
  }
  a[0]='&';  bip=2;
  for(j=2;j<jp-2;j++)                     // 2nd line -- marks-8 line
    for(i=1;i<n41-1;i++)if(tab[j][i])search(i,j);
  a[1]=bip-2;
  fwrite(a,1,bip,fp);
//-----
printf("&");  k=2;
ll:  j=a[k]; i=a[k+1]; printf("    %d_%d: ",i,j);
for(i=k+2;i<bip;i++)if(a[i]<=5)break; else printf("%c",a[i]);
printf(" %d",a[i]);
if(++i<bip){ k=i; goto ll; }  printf("\n\n");
//------
}

search(int i,int j)
{
  int jj,k,bipsave,row1,row2,row3;
  for(k=j;k<jp;k++){ tab[k][i-1]=0; if(tab[k][i]==0)break; tab[k][i]=0; }
  row1=posi[j];   row2=posi[k--];
  if(k+1!=jp){ if(row2-row1<150)return;} else row2=row1+350;
  bipsave=bip;  a[bip++]=j; a[bip++]=i;
  jj=mark(row1,row2,i,bip); a[bip++]=jj;
  row1=i+1; if(row1>=n41)row1=n41-1;
  row2=i+2; if(row2>=n41)row2=n41-1;
  row3=i+3; if(row3>=n41)row3=n41-1;
  if(jj==0 || jj==4)
    for(jj=j;jj<=k;jj++)tab[jj][row1]=tab[jj][row2]=tab[jj][row3]=0;
  else bip=bipsave;
}

int mark(int row1,int row2,int col)
{
  int i,j,k,l,bs, zm,row,mz,zp, checkcode, codesort, rsh[100],slp[100];
  row=row2-row1+60;                                 // row1-30  row2+30
  for(i=0;i<row;i++)b[i]=aa[row1-30+i][col];
  mz=m60;
  for(i=0;i<row-10;i++){
    if(b[i]<m40 || b[i]<b[i-1] || b[i]<b[i+1])continue; if(b[i]<mz)mz=b[i];
  }
  bs=0;
  for(i=60;i<row-60;i++){
    if(b[i]>=mz || b[i]>b[i-1] || b[i]>b[i+1])continue; if(b[i]>bs)bs=b[i];
  }
  bs=(mz-bs+1)/2; if(bs>p10)bs=p10; zm=mz-bs;
  zp= j= slp[0]=0;
  for(i=0;i<row;i++){
    if(zp==0 && b[i]<zm)continue;                  // head
    if(zp==0){ zp=1;  slp[j++]=calm(i,zm); }
    if(zp==1){ if(b[i]<zm){ slp[j++]=calm(i,zm); zp=2; } continue; }
    if(zp==2)  if(b[i]>zm){ slp[j++]=calm(i,zm); zp=1; }
  }
  j--; for(i=1;i<j;i++)rsh[i-1]=(slp[i]-slp[i-1]+17)/33;
  l=0; k=j; if(rsh[1]>white8)l=2; if(rsh[k-2]>white8)k=k-2;
  mz=(k-l)/6;
  if(mz==0){ printf("bad_bar_data\n"); return; }
  zm=(slp[mz*6+l]-slp[l])/(11*mz);
  for(i=l+1;i<=k;i++){
    bs=slp[i]-slp[i-1];
    if(bs<(zm*3/4)){ bs=(zm-bs)/2; slp[i]+=bs; slp[i-1]-=bs; }
  }
  j=0; for(i=l+1;i<=k;i++)slp[j++]=slp[i]-slp[i-1];
  if(slp[3]<slp[j-4])                              // reversed
    for(i=0;i<j/2;i++) { bs=slp[i]; slp[i]=slp[j-i-1]; slp[j-i-1]=bs;}
  for(i=0;i<j-1;i+=6){
    zp=(slp[i]+slp[i+1]+slp[i+2]+slp[i+3]+slp[i+4]+slp[i+5]+zm/2)/11;
    for(l=i;l<i+6;l++){
      slp[l]=(slp[l]+zp/2)/zp; if(slp[l]==0)slp[l]=1; if(slp[l]>=5)slp[l]=4;
    }
  }
  for(i=zp=l=0;i<j;i+=6){
    bs=0; for(k=0;k<6;k++){bs<<=2; bs|=slp[l++]-1;}  slp[zp++]=bs;
  } zp--;
  checkcode= l= bs=0;
  for(i=0;i<zp;i++){
    for(j=0;j<107;j++)if(slp[i]==mta[j])goto l10;
    return(1);
l10:
    slp[l++]=j;
  } l--;
  codesort=slp[0]-102;
  if(codesort<1 || codesort >3)return(2);        // no head
  if(slp[l]!=106)return(3);                      // no end
  for(i=1;i<l;i++)checkcode+=slp[i-1]*(i-1);  checkcode+=slp[0];
  checkcode%=103;
  l--;  if(checkcode!=slp[l])bs=4;               // err of check code
  for(i=1;i<l;i++)
  if(codesort==3){
    if(slp[i]==102)continue;                     // 40923 for UCC/EAN
    if(slp[i]>=100)codesort=2;
    else { a[bip++]=slp[i]/10+48; a[bip++]=slp[i]%10+48; }
  } else { if(slp[i]==99)codesort=3; else a[bip++]=slp[i]+32; }
  return(bs);
}

int calm(int i,int zm)
{
  if(b[i]==b[i-1])return i*10;
  return  i*10-(b[i]-zm)*10/(b[i]-b[i-1]);
}
